VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'**********************************************************************
'** Name: Connect
'**
'** Description: Implementation of extensibility interface

Option Explicit

Implements IDTExtensibility

Public FormDisplayed          As Boolean
Public VBInstance             As VBIDE.VBE
Dim mcbMenuCommandBar         As Office.CommandBarControl
Dim mfrmAddIn                 As New frmRenum
Public WithEvents MenuHandler As CommandBarEvents          'command bar event handler
Attribute MenuHandler.VB_VarHelpID = -1

'**********************************************************************
'** Name: Hide
'**
'** Description: Hide form

Sub Hide()
10    On Error GoTo ErrorHandling
   
20    On Error Resume Next
    
30    FormDisplayed = False
40    mfrmAddIn.Hide
    
50    Exit Sub
    
60 ErrorHandling:
70    MsgBox "Internal Error" & vbCrLf & _
        "Connect::Hide at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
   
End Sub

'**********************************************************************
'** Name: Show
'**
'** Description: Show form

Sub Show()
10    On Error GoTo ErrorHandling
  
20    On Error Resume Next
    
30    If mfrmAddIn Is Nothing Then
40        Set mfrmAddIn = New frmRenum
50    End If

60    MsgBox "Show " & Str$(VBInstance)
70    Set mfrmAddIn.VBInstance = VBInstance
80    Set mfrmAddIn.Connect = Me

90    FormDisplayed = True
100    mfrmAddIn.Show
    
110    Exit Sub

120 ErrorHandling:
130    MsgBox "Internal Error" & vbCrLf & _
        "Connect::Show at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
  
End Sub

'**********************************************************************
'** Name: AddToAddInCommandBar
'**
'** Description: Add AddIn to AddIn-Commandbar

Function AddToAddInCommandBar(sCaption As String) As Office.CommandBarControl
10    On Error GoTo ErrorHandling
    
20    Dim cbMenuCommandBar As Office.CommandBarControl  'command bar object
30    Dim cbMenu As Object
      
    '#see if we can find the Add-Ins menu
40    Set cbMenu = VBInstance.CommandBars("Add-Ins")
    
50    If cbMenu Is Nothing Then
        '# not available so we fail
60        Exit Function
70    End If
    
    '# add it to the command bar
80    Set cbMenuCommandBar = cbMenu.Controls.Add(1)

    '# set the caption
90    cbMenuCommandBar.Caption = sCaption
100    Set AddToAddInCommandBar = cbMenuCommandBar
    
110    Exit Function
    
120 ErrorHandling:
130    MsgBox "Internal Error" & vbCrLf & _
        "Connect::AddToAddInCommandBar at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description

End Function

'**********************************************************************
'** Name: IDTExtensibility_OnAddInsUpdate
'**
'** Description: This event fires, when the add-in is updated

Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
    ' do not remove this line
End Sub

'**********************************************************************
'** Name: IDTExtensibility_OnConnection
'**
'** Description: This event fires, when the add-in is connected

Private Sub IDTExtensibility_OnConnection( _
    ByVal VBInst As Object, _
    ByVal ConnectMode As VBIDE.vbext_ConnectMode, _
    ByVal AddInInst As VBIDE.AddIn, _
    custom() As Variant)
    
10    On Error GoTo ErrorHandling

    '# save the vb instance
20    Set VBInstance = VBInst
    
    '# this is a good place to set a breakpoint and
    '# test various addin objects, properties and methods
30    Debug.Print VBInst.FullName

40    If ConnectMode = vbext_cm_External Then
        '# Used by the wizard toolbar to start this wizard
50        Me.Show
60    Else
70        Set mcbMenuCommandBar = AddToAddInCommandBar("Renumber Source")
        '# sink the event
80        Set Me.MenuHandler = VBInst.Events.CommandBarEvents(mcbMenuCommandBar)
90    End If
  
100    Exit Sub
    
110 ErrorHandling:
120    MsgBox "Internal Error" & vbCrLf & _
        "Connect::IDTExtensibility_OnConnection at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
    
End Sub

'**********************************************************************
'** Name: IDTExtensibility_OnDisconnection
'**
'** Description: This event fires, when the add-in is removed from
'**              the menu

Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As VBIDE.vbext_DisconnectMode, custom() As Variant)

10    On Error GoTo ErrorHandling

20    On Error Resume Next
    
    '# delete the command bar entry
30    mcbMenuCommandBar.Delete
    
    '# shut down the Add-In
40    If FormDisplayed Then
50        FormDisplayed = False
60    End If
    
70    Unload mfrmAddIn
    
80    Set mfrmAddIn = Nothing
    
90    Exit Sub
    
100 ErrorHandling:
110    MsgBox "Internal Error" & vbCrLf & _
        "Connect::IDTExtensibility_OnDisconnection at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
End Sub

'**********************************************************************
'** Name: IDTExtensibility_OnStartupComplete
'**
'** Description: startup completed event

Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
    ' do not remove this line
End Sub

'**********************************************************************
'** Name: MenuHandler_Click
'**
'** Description: this event fires when the menu is clicked in the IDE

Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)

10    On Error GoTo ErrorHandling
    
    '# show the form
20    Me.Show
    
30    Exit Sub

40 ErrorHandling:
50    MsgBox "Internal Error" & vbCrLf & _
        "Connect::MenuHandler_Click at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
End Sub
