VERSION 5.00
Begin VB.Form frmRenum 
   Caption         =   "Renum"
   ClientHeight    =   2520
   ClientLeft      =   45
   ClientTop       =   270
   ClientWidth     =   4425
   LinkTopic       =   "Form1"
   ScaleHeight     =   2520
   ScaleWidth      =   4425
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove Numbers"
      Height          =   372
      Left            =   1440
      TabIndex        =   9
      Top             =   2040
      Width           =   1572
   End
   Begin VB.CommandButton cmdRenumber 
      Caption         =   "Renumber"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3120
      TabIndex        =   5
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CheckBox chkLeaveOld 
      Caption         =   "Leave old numbers"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1320
      Width           =   1815
   End
   Begin VB.TextBox txtIncrement 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   1200
      TabIndex        =   3
      Text            =   "10"
      Top             =   840
      Width           =   375
   End
   Begin VB.CheckBox chkGlobal 
      Caption         =   "Number Globally"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   1695
   End
   Begin VB.CheckBox chkNumEmpty 
      Caption         =   "Number Empty Line"
      Height          =   252
      Left            =   2400
      TabIndex        =   1
      Top             =   1320
      Width           =   1695
   End
   Begin VB.CheckBox chkNumComments 
      Caption         =   "Number Comments"
      Height          =   252
      Left            =   2400
      TabIndex        =   0
      Top             =   1680
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Increment"
      Height          =   252
      Left            =   120
      TabIndex        =   8
      Top             =   840
      Width           =   972
   End
   Begin VB.Label Label2 
      Caption         =   "VB Renumber"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   492
      Left            =   1080
      TabIndex        =   7
      Top             =   120
      Width           =   2412
   End
End
Attribute VB_Name = "frmRenum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**********************************************************************
'** Name: frmRenum.frm
'**
'** Description: Renumber Visual Basic Sources for Error handling.
'**
'** Copyright Mario Boller-Olfert 1999
'**
'** This is freeware.
'** You may execute this program.
'** You may change it for your own private purposes.
'** You may give this program to others free of charge and unchanged.
'** You may change the program, send it to others free of charge and
'** tell me what you have done.

Option Explicit

Public VBInstance As VBIDE.VBE
Public Connect As Connect

'**********************************************************************
'** Name: cmdCancel_Click
'**
'** Description: Cancel program execution

Private Sub cmdCancel_Click()
10    On Error GoTo ErrorHandling
    
20    Connect.Hide
    
30    Exit Sub
    
40 ErrorHandling:
50    MsgBox "Internal Error" & vbCrLf & _
        "frmRenum::cmdCancel_Click at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
End Sub

'**********************************************************************
'** Name: cmdRemove_Click
'**
'** Description: remove the line numbers from all statements

Private Sub cmdRemove_Click()

10    On Error GoTo ErrorHandling
20    Dim noLines As Integer
30    Dim i As Integer
40    Dim line As String
50    Dim token As String
60    Dim pos As Integer

    '# get the number of lines
70    On Error Resume Next
80    noLines = VBInstance.ActiveCodePane.CodeModule.CountOfLines
90    If Err.Number <> 0 Then MsgBox "No active code pane": Exit Sub
100    On Error GoTo ErrorHandling

    '# FOR all line
110    For i = 1 To noLines

        '# get next source line
120        line = VBInstance.ActiveCodePane.CodeModule.Lines(i, 1)

        '# get first token of line
130        pos = 1
140        token = GetNextToken(line, pos)

        '# IF token is a number
        '# THEN
150        If Val(token) <> 0 Then

            '# remove  the number from the line
160            line = Mid$(line, pos)

        '# ENDIF
170        End If

180        VBInstance.ActiveCodePane.CodeModule.ReplaceLine i, line

    '# END FOR
190    Next i

200    Connect.Hide

210    Exit Sub

220 ErrorHandling:
230    MsgBox "Internal Error" & vbCrLf & _
        "frmRenum::cmdRemove_Click at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
        
End Sub

'**********************************************************************
'** Name: cmdRenumber_Click
'**
'** Description: Renumber all line

Private Sub cmdRenumber_Click()
10    On Error GoTo ErrorHandling

20    Dim line As String
30    Dim lineNo As Integer
40    Dim inProcedure As Boolean
50    Dim ignore As Boolean
60    Dim leaveAlone As Boolean
70    Dim firstCase As Boolean
80    Dim nextLineIsContinuationLine As Boolean

90    Dim pos As Integer
100    Dim oldPos As Integer
110    Dim newPos As Integer
120    Dim token As String
130    Dim noLines As Integer
140    Dim increment As Integer
150    Dim i As Integer
    
    '# get entered line number increment
160    increment = Val(txtIncrement)

    '# get number of soruce lines
170    On Error Resume Next
180    noLines = VBInstance.ActiveCodePane.CodeModule.CountOfLines
190    If Err.Number <> 0 Then MsgBox "No active code pane": Exit Sub
200    On Error GoTo ErrorHandling

    '# FOR all lines
210    lineNo = increment
220    inProcedure = False
230    For i = 1 To noLines

        '# get next source line
240        line = VBInstance.ActiveCodePane.CodeModule.Lines(i, 1)
250        pos = 1
260        leaveAlone = False

        '# ignore continuation line
270        If nextLineIsContinuationLine Then
280            If Right$(line, 1) <> "_" Then
290                nextLineIsContinuationLine = False
300            End If
310            leaveAlone = True
320        Else
330            If Right$(line, 1) = "_" Then
340                nextLineIsContinuationLine = True
350            End If
360        End If
           
        '# remove existing line numbers
370        If Not leaveAlone Then
380            pos = 1
390            token = GetNextToken(line, pos)

400            If Val(token) <> 0 Then
410                If chkLeaveOld.Value = 1 Then
420                    leaveAlone = True
430                Else
440                    line = Mid$(line, pos)
450                    pos = 1
460                End If
470            Else
480                pos = 1
490            End If
500        End If
     
        '# ignore empty lines
510        If Len(Trim$(Mid$(line, pos))) = 0 Then
520            If Not chkNumEmpty.Value = 1 Then
530                leaveAlone = True
540            End If
550        End If

        '# get first token
560        token = GetNextToken(line, pos)

        '# ignore pure comment lines
570        If token = "'" Or token = "Rem" Then
580            If Not chkNumComments.Value = 1 Then
590                leaveAlone = True
600                token = ""
610            End If
620        End If

        '# FOR all tokens in one line
630        While token <> ""
        
            '# ignore comment at end of line
640            If token = "'" Or token = "Rem" Then
650                token = ""
660            End If
            
            '# remember start of procedure or function
670            If token = "Sub" Or token = "Function" Then
680                inProcedure = True
690                leaveAlone = True
700                If Not chkGlobal.Value = 1 Then
710                    lineNo = increment
720                End If
730            End If

            '# ignore conditioned compiling statements
740            If token = "#If" Or token = "#Else" Or _
                token = "#ElseIf" Or token = "#End" Or token = "#Const" Then
                
750                leaveAlone = True
760            End If
            
            '# handle end of procedure or function
770            If token = "End" Then
780                oldPos = pos
790                token = GetNextToken(line, pos)
            
800                If token = "Sub" Or token = "Function" Then
810                    inProcedure = False
820                Else
830                    pos = oldPos
840                End If
850            End If

            '# handle "Declare Function" and "Declare Sub"
860            If token = "Declare" Then
870                token = GetNextToken(line, pos)
880            End If
        
            '# handle exit functions
890            If token = "Exit" Then
900                oldPos = pos
910                token = GetNextToken(line, pos)
920                If token <> "Sub" And token <> "Function" Then pos = oldPos
930            End If
            
            '# handle first select case statement
940            If token = "Case" And firstCase Then
950                leaveAlone = True
960                firstCase = False
970            End If
            
            '# remember start of select case statement
980            If token = "Select" Then
                ' read past case keyword
990                token = GetNextToken(line, pos)
1000                firstCase = True
            
1010            End If
                
            '# get next token
1020            If token <> "" Then token = GetNextToken(line, pos)

        '# END FOR
1030        Wend
        
        ' prepend line number to line
1040        If inProcedure And Not leaveAlone Then
1050            If Left$(line, 1) <> " " Then
1060                line = Format$(lineNo, "########") & " " & line
1070            Else
1080                line = Format$(lineNo, "########") & line
1090            End If
1100            lineNo = lineNo + increment
1110        End If
        
        '# get next line
1120        VBInstance.ActiveCodePane.CodeModule.ReplaceLine i, line

1130        Next

1140    Connect.Hide

1150    Exit Sub
    
1160 ErrorHandling:
1170    MsgBox "Internal Error" & vbCrLf & _
        "frmRenum::cmdRenumber_Click at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description

End Sub

'**********************************************************************
'** Name: GetNextToken
'**
'** Description: Diese Funktion liefert in einem sting den nchsten
'**              Visual-Basic-STing, der hinter der angegebenen
'**              Position beginnt. Folgt keine token mehr nach der
'**              Position, so wird ein Leerstring zurckgegeben

Private Function GetNextToken(line As String, startPos As Integer) As String
10    On Error GoTo ErrorHandling
    
20    Dim token As String
30    Dim startToken As Integer
40    Dim endToken As Integer
50    Dim pos As Integer
60    Dim inString As Boolean
    
    '# exit if end of line reached
70    If startPos > Len(line) Then
80        GetNextToken = ""
90        Exit Function
100    End If

    '# look for start of next token
110    pos = startPos
120    While startToken = 0 And pos < Len(line)
130        If Mid$(line, pos, 1) <> " " Then
140            startToken = pos
150        Else
160            pos = pos + 1
170        End If
180    Wend
       
    '# handle: no more tokens found
190    If startToken = 0 Then
200        GetNextToken = ""
210        Exit Function
220    End If
    
    '# look for end of token
230    If Mid$(line, pos, 1) = """" Then
240        inString = True
250        While inString
260            pos = pos + 1
270            If pos > Len(line) Then
280                inString = False
290            Else
                '# handle strings
300                If Mid$(line, pos, 1) = """" Then
310                    If pos = Len(line) Then
320                        inString = False
330                    Else
340                        If Mid$(line, pos + 1, 1) <> """" Then
350                            inString = False
360                        Else
370                            pos = pos + 2
380                        End If
390                    End If
400                End If
410            End If
420        Wend
430        endToken = pos
440    End If
           
    '# handle remarks
450    If endToken = 0 And Mid$(line, pos, 1) = "'" Then
460        endToken = startToken
470    End If
    
    '# remove trailing blanks
480    While endToken = 0 And pos < Len(line)
490        If Mid$(line, pos, 1) = " " Or Mid$(line, pos, 1) = ":" Then
500            endToken = pos - 1
510        End If
520        pos = pos + 1
530    Wend
       
    '# handle token at end of line
540    If endToken = 0 Then
550        endToken = Len(line)
560    End If
        
    '# return found token
570    startPos = endToken + 1
580    GetNextToken = Mid$(line, startToken, endToken - startToken + 1)
590    Exit Function
       
600 ErrorHandling:
610    MsgBox "Internal Error" & vbCrLf & _
        "frmRenum::GetNextToken at Line " & Str$(Erl) & vbCrLf & _
        Err.Number & ": " & Err.Description
    End Function
